﻿/*
 * Created by SharpDevelop.
 * User: jt
 * Date: 24-10-2010
 * Time: 16:29
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Windows.Forms;
using System.Diagnostics;
using System.Threading;
using System.Runtime.InteropServices;
namespace HovText
{
	/// <summary>
	/// Description of Class1.
	/// </summary>
	public class ClipboardManipulator
	{
		public ClipboardManipulator()
		{
		}
		
		public bool Process(IDataObject ido)
		{
			DbgLog.Instance.Log ("Process()");

			string s = null;
			if (ido.GetDataPresent(DataFormats.UnicodeText))
			{
				DbgLog.Instance.Log ("found utf");
				s = (string)ido.GetData(DataFormats.UnicodeText);
			}
			if (s == null && ido.GetDataPresent(DataFormats.Text))
			{
				DbgLog.Instance.Log ("found text");
				s = (string)ido.GetData(DataFormats.Text);
			}				
			if (s != null)
			{
				DbgLog.Instance.Log ("got utf");
				s = ProcessString(s);
				DbgLog.Instance.Log ("trimmed utf");
				SetClipboard(s);
				DbgLog.Instance.Log ("send utf");
			}
			DbgLog.Instance.Log ("Process() - done");
			return false;
		}

		public string  ProcessString(string s)
		{
			if (Settings.Instance.RemoveWhiteSpace)
				s=s.Trim();
			return s;
		}
		
		[DllImport("user32.dll")]
		static extern IntPtr GetOpenClipboardWindow();
		[DllImport("user32.dll", SetLastError=true)]
		static extern uint GetWindowThreadProcessId(IntPtr hWnd, out uint lpdwProcessId);
		
		private void SetClipboard(object obj)
		{
			try {
				DbgLog.Instance.Log ("Setting Clipboard");
				Clipboard.SetDataObject(obj, true, 10, 50);
				DbgLog.Instance.Log ("Set Clipboard");
			}
  		    catch (ExternalException ex)
			{
			    DbgLog.Instance.Log( ex.ToString() );
			    IntPtr hWnd = GetOpenClipboardWindow();
			    if( IntPtr.Zero != hWnd )
			    {
			        uint pid = 0;
			        uint tid = GetWindowThreadProcessId( hWnd, out pid );
			        DbgLog.Instance.Log( string.Format("Process with hWnd {0}, PID {1} ({1:x}), TID {2} ({2:x}), " +
			                "name {3} has the clipboard", hWnd, pid, tid,
			                System.Diagnostics.Process.GetProcessById( (int)pid ).Modules[0].FileName ));
			    }
			}			 	
			catch (Exception ex)
			{
				DbgLog.Instance.Log ("Setting Clipboard exception:" + ex.ToString());
				if (MessageBox.Show("There was an error updating the Clipboard".GT() + "\r\n"
				                    + "Do you want HovText to restart?".GT(),
				           "HovText", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation)
				           == DialogResult.Yes)
				{
					Application.Restart();
				}
			}
		}
	}
}