﻿/*
 * Created by SharpDevelop.
 * User: jt
 * Date: 30-10-2010
 * Time: 23:37
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;

using HovText.HookManager;

namespace HovText
{
	/// <summary>
	/// Description of ShowHistoryItemForm.
	/// </summary>
	public partial class ShowHistoryItemForm : Form
	{
		static object lockObj = new object();
		static DateTime end;
		public ShowHistoryItemForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
		}
		
		[DllImport("user32.dll")]
		public static extern bool SetForegroundWindow(IntPtr hWnd);
		
		static ShowHistoryItemForm form = null;
		static Action OnCloseAction =null;
		public static void ShowBox(object obj, Action OnClose, Color BkColor)
		{
			lock (lockObj )
			{
				OnCloseAction = OnClose;
				end = DateTime.Now.AddMilliseconds(20000);
				if (form == null)
				{
					
					int x=-1, y =-1;
					Rectangle b = Screen.PrimaryScreen.Bounds;
					x = b.Width - ( 4 + Settings.Instance.HistoryBoxWidth);
					y = b.Height - (4 + Settings.Instance.HistoryBoxHeight);
					Taskbar tb = new Taskbar();
					if (Screen.PrimaryScreen.Bounds.Contains(tb.Location))
					{
						if (tb.Position == TaskbarPosition.Bottom )
							y = b.Height - (tb.Bounds.Height +Settings.Instance.HistoryBoxHeight + 4);
				        else if (tb.Position == TaskbarPosition.Right )
				        	x = b.Width - (tb.Bounds.Width + Settings.Instance.HistoryBoxWidth +4);
				        else if (tb.Position == TaskbarPosition.Left )
				        	x = tb.Bounds.Width + 4;
				        else if (tb.Position == TaskbarPosition.Top )
				        	y = tb.Bounds.Height +4;
					}
					form =new ShowHistoryItemForm();
					form.Height = Settings.Instance.HistoryBoxHeight;
					form.Width = Settings.Instance.HistoryBoxWidth;
					form.Top = y ;
					form.Left = x;
					form.label1.Font = Settings.Instance.Font;
					
					form.Show();
				}
				
				if (obj is string)
				{
					form.label1.Text = (string)obj;
					form.label1.Visible = true;
				}
				else
					form.label1.Visible = false;
				if (obj is Bitmap)
				{
					form.pictureBox1.Image = (Bitmap) obj;
					form.SetImage(form.pictureBox1);
					form.pictureBox1.Visible = true;
				} else
					form.pictureBox1.Visible = false;
				 form.BackColor = BkColor;
				SetForegroundWindow(form.Handle);
			}
		}
		
		public Size GenerateImageDimensions(int currW, int currH, int destW, int destH)
		{
		    double multiplier = 0;
		    if (destH > destW)
		        multiplier = (double)destW / (double)currW;
		    else
		        multiplier = (double)destH / (double)currH;
		    return new Size((int)(currW * multiplier), (int)(currH * multiplier));
		}

		private void SetImage(PictureBox pb)
		{
	        pb.SizeMode = PictureBoxSizeMode.CenterImage;
			if (pb.Image.Width>form.pictureBox1.Width || pb.Image.Height>form.pictureBox1.Height)
			{
		        Image img = pb.Image;
		        Size imgSize = GenerateImageDimensions(img.Width, img.Height, this.pictureBox1.Width, this.pictureBox1.Height);
		        Bitmap finalImg = new Bitmap(img, imgSize.Width, imgSize.Height);
		        Graphics gfx = Graphics.FromImage(img);
		        gfx.InterpolationMode = InterpolationMode.HighQualityBicubic;
		        pb.Image = finalImg;
			}
		}
	
		public static bool IsVisible()
		{
			lock (lockObj )
			{
				end = DateTime.Now.AddMilliseconds(350);
				return form !=null;
			}
		
		}
		
		Timer timer1 ;
		
		void ShowHistoryItemFormShown(object sender, EventArgs e)
		{
			lock (lockObj )
			{
				timer1 = new Timer();
				timer1.Tick += delegate 
				{ 
					this.ChkClose();
				};
				timer1.Interval = 50;
				timer1.Start();
			}
		}
		
		
		
		
		void ChkClose()
		{
			lock (lockObj )
			{
				if (DateTime.Now> end && form != null)
				{
					timer1.Stop();
					timer1 = null;
					form = null;
					BeginInvoke( new MethodInvoker( this.Close));
					OnCloseAction();
				}
			}
		}
		
		void ForceClose()
		{
			lock (lockObj)
			{
				end =DateTime.Now;
				ChkClose();
			}
		}
		
		
		void GlobalEventProvider1KeyDown(object sender, KeyEventArgs e)
		{
			if (e.KeyCode != Keys.LShiftKey &&
			    e.KeyCode != Keys.RShiftKey &&
			    e.KeyCode != Keys.ShiftKey &&
				(e.KeyCode != Settings.Instance.HistoryHotKey.KeyCode
			    || e.Alt != Settings.Instance.HistoryHotKey.Alt
			    || e.Control != Settings.Instance.HistoryHotKey.Control)
			   )
			{
				ForceClose();
			}
		}
		
		void GlobalEventProvider1MouseClick(object sender, MouseEventArgs e)
		{
			ForceClose();
		}
	}
}
