﻿/*
 * Created by SharpDevelop.
 * User: jt
 * Date: 02-04-2011
 * Time: 20:01
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Reflection;

namespace HovText
{
	/// <summary>
	/// Description of VersionInfo.
	/// </summary>
	public sealed class VersionInfo
	{
		private static VersionInfo instance = new VersionInfo();
		private	Assembly asm;
		private Version ver;
		private object[] attrs;
		private	string configuration;
		
		public static VersionInfo Instance {
			get {
				return instance;
			}
		}
		
		public  string GetString()
		{
			return 	ver.ToString() + configuration;
		}
		

		public bool IsAlpha()
		{
			return configuration.Contains("alpha");
		}

		public bool IsBeta()
		{
			return configuration.Contains("beta");
		}
		
		private VersionInfo()
		{
			asm = Assembly.GetExecutingAssembly();
			ver = asm.GetName().Version;
			attrs =asm.GetCustomAttributes(false);
			 configuration= "";
			foreach (object obj in attrs)
			{
				if (obj is AssemblyConfigurationAttribute)
				{
					configuration += "." + ((AssemblyConfigurationAttribute)obj).Configuration;
					break;
				}
			}
		}
	}
}
